{% extends 'dashboard/dashboard_content.html' %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>

{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-plus"></i>
                Grant On duty
            </h2>
            {% if od_request %}
                <ul class="nav navbar-right panel_toolbox">
                    <li>
                        <a class="save btn btn-sm btn-info" href="../{{ od_request.student.roll_no }}" target="_blank"
                           style="color: #5b06b5">{{ od_request.student }} Profile </a>
                    </li>
                </ul>
            {% endif %}
            <div class="clearfix"></div>
        </div>
        <div class="container" align="center">
            <div role="alert" class="alert alert-warning alert-dismissible fade in" align="center">
                <button aria-label="Close" data-dismiss="alert" class="close" type="button"><span
                        aria-hidden="true">×</span>
                </button>
                {% if od_request %}
                    <p><em> You can alter the OD details </em></p>
                {% else %}
                    <p><em><h5> Start and End date are same if it is only ONE DAY OD </h5></em></p>
                {% endif %}
            </div>
        </div>
        <div class="x_content">
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <form id="demo-form2" class="form-horizontal form-label-left">
                        <div class="form-horizontal form-label-left">
                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Register Number
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input class="form-control" placeholder="Register number of the student" type="text"
                                           required
                                           id="roll_no" value="{{ od_request.student.roll_no }}"
                                            {% if od_request %}
                                           disabled
                                            {% endif %}
                                    >
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Reason
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                <textarea id="reason" class="form-control" type="text" name="roll_no"
                                          maxlength="1500" placeholder="Reason for OD"
                                          required>{{ od_request.message }}</textarea>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Start Date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="datepicker" class="form-control" type="text"
                                           value="{{ start_date }}" required readonly>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    End Date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="enddatepicker" class="form-control" type="text"
                                           value="{{ end_date }}" required readonly>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <button id="add" type="submit" class="btn1 btn-dark-green">Issue OD</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div class="container" align="center" id="alertlink" style="display: none">
                <div role="alert" class="alert alert-warning alert-dismissible fade in" align="center">
                    <button aria-label="Close" data-dismiss="alert" class="close" type="button"><span
                            aria-hidden="true">×</span>
                    </button>
                    <div id="titlelist">
                    </div>
                </div>
            </div>
            <form class="form-horizontal form-label-left" id="tablecontent" style="display: none">
                <div class="container" align="center">
                    <div role="alert" class="alert alert-success alert-dismissible fade in" align="center">
                        <h4><strong> Full Day ODs </strong></h4>
                    </div>
                </div>
                <div class="table-responsive">
                    <div>
                        <table class="table table-hover" style="">
                            <thead>
                            <tr>
                                <th>S. No.</th>
                                <th>Provided By</th>
                                <th>Roll No</th>
                                <th>Name</th>
                                <th>Reason</th>
                                <th>Start Date</th>
                                <th>End Date</th>
                            </tr>
                            </thead>
                            <tbody id="content">

                            </tbody>
                        </table>
                    </div>
                </div>
            </form>
            <form class="form-horizontal form-label-left" id="tablecontent1" style="display: none">
                <div class="container" align="center">
                    <div role="alert" class="alert alert-success alert-dismissible fade in" align="center">
                        <h4><strong> Hourly ODs </strong></h4>
                    </div>
                </div>
                <div class="table-responsive">
                    <div>
                        <table class="table table-hover" style="">
                            <thead>
                            <tr>
                                <th>S. No.</th>
                                <th>Provided By</th>
                                <th>Roll No</th>
                                <th>Name</th>
                                <th>Reason</th>
                                <th>Date</th>
                                <th>Hours</th>
                            </tr>
                            </thead>
                            <tbody id="content1">

                            </tbody>
                        </table>
                    </div>
                </div>
            </form>
        </div>
    </div>

    <form id="dummy_form" method="POST">
        {% csrf_token %}
    </form>

    <script type="text/javascript">

        $(function () {
            $("#datepicker").datepicker({dateFormat: 'dd/mm/yy'});
        });

        $(function () {
            $("#enddatepicker").datepicker({
                dateFormat: 'dd/mm/yy',
                minDate: $("#datepicker").datepicker("getDate")
            });
        });

        {% if error == 'holiday' %}
            $(function () {
                new PNotify({
                    title: 'Warning!',
                    text: 'Start or End date cannot be a holiday',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        {% if error == 'success' %}
            $(function () {
                new PNotify({
                    title: 'Success!',
                    text: '{{ success_message }}',
                    type: 'success',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}
        {% if error == 'duplicate' %}
            $(function () {
                new PNotify({
                    title: 'Oh Snap!',
                    text: '{{ crash_message }}',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}


        $(document).on("focusout", '#roll_no', function (e) {
            var roll_no = $('#roll_no').val();
            if (roll_no.length == 0) {
                alert('Enter proper reg. no.');
                $('#roll_no').val('');
                $('#roll_no').focus();
                return;
            }

            $.ajax({
                type: "POST",
                data: {
                    check_roll: true,
                    roll_no: $('#roll_no').val(),
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'grandod' %}',
                success: function (data) {
                    document.getElementById('content').innerHTML = "";
                    document.getElementById('content1').innerHTML = "";
                    counter = 1;
                    if (data.error == 'true') {
                        $('#roll_no').val('');
                        $('#roll_no').focus();
                        $(function () {
                            new PNotify({
                                title: 'Oh Snap!',
                                text: 'Register Number does not exist',
                                type: 'error',
                                styling: 'bootstrap3',
                                min_height: "20px",
                                mobile: {'styling': true}
                            });
                        });
                        $('#alertlink').hide();
                        $('#tablecontent').hide();
                        $('#tablecontent1').hide();
                    }
                    else {
                        $('#alertlink').show();
                        $('#titlelist').empty();
                        $('#titlelist').append('<h4>OD list of student <strong>' + data.student_name + '</strong></h4>');
                        $('#tablecontent').show();
                        $('#tablecontent1').show();
                        $.each(data.list, function (key, val) {
                            document.getElementById('content').innerHTML += '<tr>' +
                                '<td>' + counter++ + '</td>' +
                                '<td>' + val.staff_name + '</td>' +
                                '<td><a href="../' + val.student_roll + '" target="_blank" >' + val.student_roll + '</a></td>' +
                                '<td>' + val.student_name + '</td>' +
                                '<td style=\"word-wrap: break-word\">' + val.reason + '</td>' +
                                '<td>' + val.start_date + '</td>' +
                                '<td>' + val.end_date + '</td></tr>';
                        })
                        $.each(data.hourly_list, function (key, val) {
                            document.getElementById('content1').innerHTML += '<tr>' +
                                '<td>' + counter++ + '</td>' +
                                '<td>' + val.staff_name + '</td>' +
                                '<td><a href="../' + val.student_roll + '" target="_blank" >' + val.student_roll + '</a></td>' +
                                '<td>' + val.student_name + '</td>' +
                                '<td style=\"word-wrap: break-word\">' + val.reason + '</td>' +
                                '<td>' + val.date + '</td>' +
                                '<td>' + val.hours + '</td></tr>';
                        })
                    }
                }
            });
        });

        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $(document).on("submit", '#demo-form2', function (e) {
            e.preventDefault();
            var roll_no = $('#roll_no').val();
            var start_date = $('#datepicker').datepicker('getDate');
            var end_date = $('#enddatepicker').datepicker('getDate');
            //alert(chosen_date);
            //max_date = new Date();
            //alert(max_date);

            if (roll_no.length == 0) {
                alert('Enter proper roll no');
                return;
            }

            if (start_date > end_date) {
                alert('Start date cannot exceed end date');
                $('#datepicker').val("");
                $('#datepicker1').val("");
                $('#datepicker').focus();
                return;
            }

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#roll_no').val(), name: 'roll_no'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#reason').val(), name: 'reason'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#datepicker').val(), name: 'date'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#enddatepicker').val(), name: 'enddate'});
            $hiddenInput.appendTo('form');

            $('#dummy_form').submit();
        });
    </script>

{% endblock %}